%{?python_enable_dependency_generator}
%bcond_with tests
%global         camelname CherryPy

Summary:        Pythonic, object-oriented web development framework
Name:           python-cherrypy
Version:        18.8.0
Release:        5%{?dist}
License:        BSD
URL:            https://cherrypy.dev/
Source0:        https://files.pythonhosted.org/packages/source/C/%{camelname}/%{camelname}-%{version}.tar.gz

Patch3000:      pytest-ignore-cgi-DeprecationWarnings.patch
Patch3001:      pytest-ignore-urllib3-pyopenssl-DeprecationWarnings.patch

BuildRequires:  dos2unix python3-devel python3dist(setuptools) python3dist(setuptools-scm)
%if %{with tests}
BuildRequires:  python3dist(cheroot) python3dist(jaraco-collections) python3dist(path) python3dist(portend)
BuildRequires:  python3dist(pytest) python3dist(pytest-cov) python3dist(requests-toolbelt)
BuildRequires:  python3dist(more-itertools) python3dist(coverage) python3dist(pytest) python3-zc-lockfile
%endif

BuildArch:      noarch

%description
%{camelname} allows developers to build web applications in much the same way\
they would build any other object-oriented Python program. This usually\
results in smaller source code developed in less time.

%package -n python3-cherrypy
Summary: Pythonic, object-oriented web development framework
%{?python_provide:%python_provide python3-cherrypy}

%description -n python3-cherrypy
%{camelname} allows developers to build web applications in much the same way\
they would build any other object-oriented Python program. This usually\
results in smaller source code developed in less time.

%prep
%autosetup -p1 -n %{camelname}-%{version}
dos2unix cherrypy/tutorial/tutorial.conf
sed -i 's/readfp/read_file/' cherrypy/lib/reprconf.py

%build
%py3_build

%install
%py3_install

%if %{with tests}
%check
export WEBTEST_INTERACTIVE=false
%pytest cherrypy/test \
  --deselect=cherrypy/test/test_tools.py::ToolTests::testCombinedTools \
  -p no:unraisableexception
%endif

%files -n python3-cherrypy
%license LICENSE.md
%doc README.rst
%doc cherrypy/tutorial
%{_bindir}/cherryd
%{python3_sitelib}/*
%exclude %{python3_sitelib}/cherrypy/cherryd
%exclude %{python3_sitelib}/cherrypy/test
%exclude %{python3_sitelib}/cherrypy/tutorial

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 18.8.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 18.8.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 18.8.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 18.8.0-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Jan 13 2023 Miaojun Dong <zoedong@tencent.com> - 18.8.0-1
- initial build
